
            XDEF      IIC_init, setTime, getTime, isLeapYear     ; zpristupneni funkci ovladace okoli
            XDEF      setAlarm, resAlarm, getAlarm, writeByte, readByte, alarm 
            XDEF      enableAlarm, setTimeFormat, getTimeFormat, outFrequency
          
IICEN       equ       7
TXAK        equ       3
TX          equ       4
MST         equ       5
SRW         equ       2
IICIF       equ       1
RSTA        equ       2


            INCLUDE 'derivative.inc'


; variable/data section
MY_ZEROPAGE: SECTION  SHORT             ; Insert here your data definition


; code section
MyCode:     SECTION



;*************************************************************************************
;*
;* podprogram IIC_init - inicializace kitu
;* void IIC_init();
;*
;*************************************************************************************

IIC_init: 
            bset    IICEN,IIC1C
            bset    TXAK,IIC1C
            bclr    MST,IIC1C
            lda     #$59
            sta     IIC1F
            bclr    SRW,IIC1S
            ldx     #$95                 ;kalibrace
            lda     #$08
            jsr     IIC_write_byte
            rts
            

;*************************************************************************************
;*
;* podprogram enableAlarm - povoleni budiku
;* void enableAlarm(byte budik);
;*
;*************************************************************************************   
enableAlarm:
            
            cmp     #7                  ;pokud je budik > 7 preskoc
            bgt     preskoc1
            lsla
            lsla                        ;posun o 4 mista vlevo
            lsla
            lsla
            psha
            lda     #$07
            jsr     IIC_read_byte
            and     #%11001111
            ora     1,sp
            tax                         ;A do X
            pula
            lda     #$07                ;nacti adresu
            jsr     IIC_write_byte      ;zapis
preskoc1:
            rts
            
            
;*************************************************************************************
;*
;* podprogram setTimeFormat - nastaveni formatu hodin (24/12 hod. format)
;* void setTimeFormat(byte format);
;*
;*************************************************************************************               
setTimeFormat:
            pshx
            pshh
            cmp     #0                  
            beq     skoc3                
            lda     #$02                ;format == 1, nacti adresu
            jsr     IIC_read_byte       ;nacti hodiny
            ora     #%01000000          ;nastav bit 6 na 1 -> 12 hod format
            tax                         ;A do X
            lda     #$02                ;nacti adresu
            jsr     IIC_write_byte      ;zapis
            bra     skoc4
skoc3:                                  ;format == 0
            lda     #$02
            jsr     IIC_read_byte
            and     #%00111111          ;vynuluj bit 6 -> 24 hod format
            tax
            lda     #$02
            jsr     IIC_write_byte
skoc4:            
            pulh
            pulx
            rts
            

;*************************************************************************************
;*
;* podprogram getTimeFormat - nacte format casu, 0 = 24 hod, 1 = 12 hod
;* byte getTimeFormat(void);
;*
;*************************************************************************************               
getTimeFormat:
            lda     #$02                ;nacti adresu
            jsr     IIC_read_byte       ;precti byte z adresy
            and     #$40                ;vymaskuj bity
            lsra
            lsra
            lsra
            lsra
            lsra
            lsra
            rts
            
 
 ;*************************************************************************************
;*
;* podprogram outFrequency - povoleni vystupni frekvence z MFP pinu
;* !!! pokud je aktivni, neni mozne pouzit preruseni od budiku !!! 
;* void outFrequency(byte povolit, byte frekv);
;*
;*************************************************************************************   
 outFrequency:
            pshx
            pshh
            psha
            
            cmp     #7                  ;pokud je frekv > 7 preskoc
            bgt     preskoc2
            txa                         ;nacti povolit do A
            cmp     #1                  ;pokud je vetsi nez 1 preskoc
            bgt     preskoc2
            lda     #$07                ;
            jsr     IIC_read_byte       ;nacti puvodni hodnotu
            and     #%00110000
            psha                        ;uloz si ji na zasobnik
            txa                         ;nacti povolit do A
            lsla
            lsla
            lsla                        ;rotace o 6 vlevo
            lsla
            lsla
            lsla
            ora     1,sp                ;log. soucet s puvodni hodnotou
            ora     2,sp                ;log soucet s frekv
            tax
            lda     #$07                ;zapis
            jsr     IIC_write_byte
            pula
preskoc2:
            pula
            pulh
            pulx
            rts               



;*************************************************************************************
;*
;* podprogram setTime - nastaven asu - nastavi vybrany byte na zadanou hodnotu
;* void setTime(byte volba, byte hodnota)
;*
;*************************************************************************************            
setTime:
            pshx                        
            pshh
            jsr     toBCD               ;hodnota do BCD
            psha                        ;uloit A na zasobnik         
            txa                         ; X do A
            cmp     #1                  ;switch volby
            beq     case1               ; = 1
            cmp     #2
            beq     case2
            cmp     #3
            beq     case3
            cmp     #4
            beq     case4
            cmp     #5
            beq     case5
            cmp     #6
            beq     case6
            cmp     #7
            beq     case7
            cmp     #8
            beq     case8
            jmp     konec
            
case1:                                  ;den v tydnu      
            pula
            tax                         ;hodnota do X
            lda     #$03                ;adresa do A
            jsr     IIC_write_byte
            bra     konec            
case2:
            pula                        ;den v mesici
            tax
            lda     #$04
            jsr     IIC_write_byte
            bra     konec           
case3:                                  ;mesic
            pula
            tax
            lda     #$05
            jsr     IIC_write_byte
            bra     konec
case4:                                  ;rok
            pula
            tax
            lda     #$06
            jsr     IIC_write_byte
            bra     konec           
case5:                                  ;hodiny
            jsr     getTimeFormat       ;zjisti format casu
            ora     1,sp                ;udelej A | hodnota
            tax                         ;hodnota do X
            pula                        ;vyprazdni zasobnik
            lda     #$02                ;nacti adresu do A                
            jsr     IIC_write_byte      ;zapis
            bra     konec
case6:                                  ;minuty
            pula
            tax
            lda     #$01
            jsr     IIC_write_byte
            bra     konec
case7:                                  ;sekundy
            pula
            ora     #%10000000          ;zajisti zpis 1 to nejvyssiho bitu
            tax
            lda     #$00
            jsr     IIC_write_byte
            bra     konec
case8:                                  ;AM/PM
            pula                        ;nacti hodnotu ze zas.
            lsla                        ;posun o 5 mist do leva
            lsla
            lsla
            lsla
            lsla
            psha                        ;uloz na zas.
            lda     #$02                ;nacti adresu
            jsr     IIC_read_byte       ;nactu hodiny do A
            and     #%01011111          ;vynuluj bit AM/PM
            ora     1,sp                ;log. soucet hodin s novou AM/PM 
            tax                         ;hodnota hodin do X
            pula                        ;vyprazdneni zasobniku
            lda     #$02                ;nacti adresu
            jsr     IIC_write_byte      ;zapis                      
konec:      
            pulh
            pulx
            feed_watchdog
            rts
            
;*************************************************************************************
;*
;* podprogram getTime - nacteni casu - nacte vybrany byte
;* byte getTime(byte cislo);
;*
;*************************************************************************************           
getTime:
            cmp     #1                  ;switch volby
            beq     case21              ; = 1
            cmp     #2
            beq     case22
            cmp     #3
            beq     case23
            cmp     #4
            beq     case24
            cmp     #5
            beq     case25
            cmp     #6
            beq     case26
            cmp     #7
            beq     case27
            cmp     #8
            beq     case28
            jmp     konec2
            
case21:                                 ;den v tydnu      
            lda     #$03                ;nacti adresu
            jsr     IIC_read_byte       ;nacti hodnotu
            and     #%00000111          ;vymaskuj bity
            
            bra     konec2            
case22:                                 ;den v mesici
            lda     #$04                
            jsr     IIC_read_byte
            bra     konec2           
case23:                                 ;mesic
            lda     #$05
            jsr     IIC_read_byte
            and     #%00011111
            bra     konec2
case24:                                 ;rok
            lda     #$06
            jsr     IIC_read_byte
            bra     konec2           
case25:                                 ;hodiny
            jsr     getTimeFormat       ;zjisti format casu
            cmp     #0                  ;je rovno 0? tj. 24 hod. format
            beq     preskoc             ;jdi na preskoc
            lda     #$02                ;nacti adresu -> 12 hod format
            jsr     IIC_read_byte       ;nacti hodnotu
            and     #%00011111          ;vymaskuj
            bra     konec2              ;konec
preskoc:    
            lda     #$02                ;nacti adresu
            jsr     IIC_read_byte       ;nacti hodnotu
            and     #%00111111          ;vymaskuj
            bra     konec2               
case26:                                 ;minuty
            lda     #$01
            jsr     IIC_read_byte
            bra     konec2
case27:                                 ;sekundy
            lda     #$00
            jsr     IIC_read_byte
            and     #%01111111          ;vynuluj nejvyssi bit
            bra     konec2
case28:                                 ;AM/PM
            lda     #$02                ;nacti adresu
            jsr     IIC_read_byte
            and     #%00100000          ;vynuluj vse krome AM/PM bitu
            ror     5                   ;posun o 5 mist vpravo                                                                   
konec2:     
            jsr     fromBCD             ;prevod z BCD 
            feed_watchdog 
            rts

;*************************************************************************************
;*
;* podprogram setAlarm - nastavi hodnotu casu pro vybrany budik a byte
;* void setAlarm(byte budik, byte cislo, byte hod) 
;* 
;*************************************************************************************
      
setAlarm:
            pshx
            pshh
                     
            jsr     toBCD               ;preved do BCD
            psha                        ;uloz na zasobnik
           
            lda     6,sp                ;nacti budik  
            cmp     #1                  ;budik == 1
            beq     jedna               ;
            cmp     #2                  ;budik == 2
            beq     cont
            jmp     konec3              ;nic
cont:                                   ;osetreni error A1401
            jmp     dva       
jedna:
            txa
            cmp     #1                  ;switch volby
            beq     case31
            cmp     #2
            beq     case32
            cmp     #3
            beq     case33
            cmp     #4
            beq     case34
            cmp     #5
            beq     case35
            cmp     #6
            beq     case36
            cmp     #7
            beq     case37
            cmp     #8
            beq     case38
            bra     konec3

case31:                                 ;rezim
            lda     #$0D                ;nacti adresu
            jsr     IIC_read_byte       ;nacti puvodni hodnoty
            and     #%00001111          ;vynuluj horni 4 bity
            psha                        ;uloz na zasobnik
            lda     2,sp                ;nacti hodnotu rezimu ze zasobniku
            lsla
            lsla                        ;rotace o 4 vlevo
            lsla
            lsla
            ora     #%10000000          ;nastav na 1 nevyssi bit
            ora     1,sp                ;log. soucet s puvodni hodnotou ze zasobniku
            tax                         ;nacti A do X
            pula                        ;vyprazdni zasobnik
            lda     #$0D                ;nacti adresu
            jsr     IIC_write_byte      ;zapis rezim s puvodni hodnotou
            bra     konec3
case32:                                 ;den v tydnu 
            lda     #$0D                ;nacti adresu
            jsr     IIC_read_byte       ;nacti puvodni hodnotu
            and     #%01110000          ;zachovej nastaveny rezim
            ora     #%10000000          ;nastav bit 7 na 1
            ora     1,sp                ;nacti den v tydnu
            tax
            lda     #$0D
            jsr     IIC_write_byte
            bra     konec3
case33:                                 ;den v mesici
            ldx     1,sp                
            lda     #$0E
            jsr     IIC_write_byte
            bra     konec3
case34:                                 ;mesic
            ldx     1,sp
            lda     #$0F
            jsr     IIC_write_byte
            bra     konec3
case35:                                 ;hodiny
            ldx     1,sp
            lda     #$0C
            jsr     IIC_write_byte
            bra     konec3
case36:                                 ;minuty 
            ldx     1,sp
            lda     #$0B
            jsr     IIC_write_byte
            bra     konec3
case37:                                 ;sekundy                       
            ldx     1,sp
            lda     #$0A
            jsr     IIC_write_byte
            bra     konec3
case38:                                 ;AM/PM
            lda     1,sp                ;nacti hodnotu
            lsla
            lsla
            lsla                        ;rotace o 5 vlevo
            lsla                        
            lsla
            psha                        ;uloz na zasobnik
            lda     #$0C                ;nacti adresu
            jsr     IIC_read_byte       ;nacti puvodni hodnotu
            ora     1,sp                ;nastav AM/PM bit
            tax                         ;uloz A do X
            pula                        ;vyprazdni zasobnik
            lda     #$0C                ;nacti adresu
            jsr     IIC_write_byte      ;zapis hodnotu
konec3:
            jmp     konec4
dva:
            txa
            cmp     #1                  ;switch volby
            beq     case41
            cmp     #2
            beq     case42
            cmp     #3
            beq     case43
            cmp     #4
            beq     case44
            cmp     #5
            beq     case45
            cmp     #6
            beq     case46
            cmp     #7
            beq     case47
            cmp     #8
            beq     case48
            bra     konec4

case41:                                 ;rezim
            lda     #$14                ;nacti adresu
            jsr     IIC_read_byte       ;nacti puvodni hodnoty
            and     #%00001111          ;vynuluj horni 4 bity
            psha                        ;uloz na zasobnik
            lda     2,sp                ;nacti hodnotu rezimu ze zasobniku
            lsla
            lsla                        ;rotace o 4 vlevo
            lsla
            lsla
            ora     #%10000000          ;nastav na 1 nevyssi bit
            ora     1,sp                ;log. soucet s puvodni hodnotou ze zasobniku
            tax                         ;nacti A do X
            pula                        ;vyprazdni zasobnik
            lda     #$14                ;nacti adresu
            jsr     IIC_write_byte      ;zapis rezim s puvodni hodnotou
            bra     konec4
case42:                                 ;den v tydnu 
            lda     #$14                ;nacti adresu
            jsr     IIC_read_byte       ;nacti puvodni hodnotu
            and     #%01110000          ;zachovej nastaveny rezim
            ora     #%10000000          ;nastav bit 7 na 1
            ora     1,sp                ;nacti den v tydnu
            tax
            lda     #$14
            jsr     IIC_write_byte
            bra     konec4
case43:                                 ;den v mesici
            ldx     1,sp                
            lda     #$15
            jsr     IIC_write_byte
            bra     konec4
case44:                                 ;mesic
            ldx     1,sp
            lda     #$16
            jsr     IIC_write_byte
            bra     konec4
case45:                                 ;hodiny
            ldx     1,sp
            lda     #$13
            jsr     IIC_write_byte
            bra     konec4
case46:                                 ;minuty 
            ldx     1,sp
            lda     #$12
            jsr     IIC_write_byte
            bra     konec4
case47:                                 ;sekundy                       
            ldx     1,sp
            lda     #$11
            jsr     IIC_write_byte
            bra     konec4
case48:                                 ;AM/PM
            lda     1,sp                ;nacti hodnotu
            lsla
            lsla
            lsla                        ;rotace o 5 vlevo
            lsla                        
            lsla
            psha                        ;uloz na zasobnik
            lda     #$13                ;nacti adresu
            jsr     IIC_read_byte       ;nacti puvodni hodnotu
            ora     1,sp                ;nastav AM/PM bit
            tax                         ;uloz A do X
            pula                        ;vyprazdni zasobnik
            lda     #$13                ;nacti adresu
            jsr     IIC_write_byte      ;zapis hodnotu
            bra     konec4
           
konec4:           
            pula
            pulh
            pulx
            feed_watchdog
            rts


;*************************************************************************************
;*
;* podprogram getAlar - nacteni nastaveni budiku
;* byte getAlarm(byte budik, byte cislo)
;*
;*************************************************************************************
getAlarm:
            pshx
            pshh
            psha
            
            txa
            cmp     #1
            beq     jedna1
            cmp     #2
            beq     dva1
            jmp     konec9
dva1:
            jmp     dva11
            
jedna1: 
            pula
            cmp     #1                  ;switch volby
            beq     case51
            cmp     #2
            beq     case52
            cmp     #3
            beq     case53
            cmp     #4
            beq     case54
            cmp     #5
            beq     case55
            cmp     #6
            beq     case56
            cmp     #7
            beq     case57
            cmp     #8
            beq     case58
            jmp     konec9
case51:
            lda     #$0D                ;rezim
            jsr     IIC_read_byte
            and     #%01110000
            lsra
            lsra
            lsra
            lsra
            jmp     konec9
case52:
            lda     #$0D                ;den v tydnu
            jsr     IIC_read_byte
            and     #%00000111
            jmp     konec9
case53:
            lda     #$0E                ;den v mesici
            jsr     IIC_read_byte
            jmp     konec9
case54:
            lda     #$0F                ;mesic
            jsr     IIC_read_byte
            jmp     konec9
case55:
            jsr     getTimeFormat       ;zjisti format casu
            cmp     #0                  ;je rovno 0? tj. 24 hod. format
            beq     preskoc3            ;jdi na preskoc
            lda     #$0C                ;nacti adresu -> 12 hod format
            jsr     IIC_read_byte       ;nacti hodnotu
            and     #%00011111          ;vymaskuj
            jmp     konec9              ;konec
preskoc3:    
            lda     #$0C                ;nacti adresu
            jsr     IIC_read_byte       ;nacti hodnotu
            and     #%00111111          ;vymaskuj
            jmp     konec9           
case56:
            lda     #$0B                ;minuty
            jsr     IIC_read_byte
            jmp     konec9
case57:
            lda     #$0A                ;sekundy
            jsr     IIC_read_byte
            jmp     konec9
case58:             
            lda     #$0C                ;AM/PM
            jsr     IIC_read_byte
            and     #%00100000
            lsra
            lsra
            lsra
            lsra
            lsra
            jmp     konec9
            
dva11:
            pula
            cmp     #1                  ;switch volby
            beq     case61
            cmp     #2
            beq     case62
            cmp     #3
            beq     case63
            cmp     #4
            beq     case64
            cmp     #5
            beq     case65
            cmp     #6
            beq     case66
            cmp     #7
            beq     case67
            cmp     #8
            beq     case68
            jmp     konec9
case61:
            lda     #$14                ;rezim
            jsr     IIC_read_byte
            and     #%01110000
            lsra
            lsra
            lsra
            lsra
            jmp     konec9
case62:
            lda     #$14                ;den v tydnu
            jsr     IIC_read_byte
            and     #%00000111
            jmp     konec9
case63:
            lda     #$15                ;den v mesici
            jsr     IIC_read_byte
            jmp     konec9
case64:
            lda     #$16                ;mesic
            jsr     IIC_read_byte
            jmp     konec9
case65:
            jsr     getTimeFormat       ;zjisti format casu
            cmp     #0                  ;je rovno 0? tj. 24 hod. format
            beq     preskoc4            ;jdi na preskoc
            lda     #$13                ;nacti adresu -> 12 hod format
            jsr     IIC_read_byte       ;nacti hodnotu
            and     #%00011111          ;vymaskuj
            bra     konec9              ;konec
preskoc4:    
            lda     #$13                ;nacti adresu
            jsr     IIC_read_byte       ;nacti hodnotu
            and     #%00111111          ;vymaskuj
            bra     konec9           
case66:
            lda     #$12                ;minuty
            jsr     IIC_read_byte
            jmp     konec9
case67:
            lda     #$11                ;sekundy
            jsr     IIC_read_byte
            jmp     konec9
case68:             
            lda     #$13                ;AM/PM
            jsr     IIC_read_byte
            and     #%00100000
            lsra
            lsra
            lsra
            lsra
            lsra            
konec9:            
            jsr     fromBCD
            pulh
            pulx
            feed_watchdog
            rts

;*************************************************************************************
;*
;* podprogram resAlarm - vynuluje bit ktery se nastavi pri spusteni alarmu
;* void resAlarm(byte budik)
;*
;*************************************************************************************

resAlarm:
            pshx
            pshh
            
            cmp     #1                    
            beq     alarm1
            cmp     #2
            beq     alarm2
            jmp     konec5
alarm1:
            lda     #$0D                ;nacti adresu
            jsr     IIC_read_byte       ;nacti byte
            and     #%11110111          ;vynuluj alarm1
            tax                         ;uloz A do X
            lda     #$0D                ;nacti adresu
            jsr     IIC_write_byte       ;zapis hodnotu
            jmp     konec5          
alarm2:            
            lda     #$14                ;nacti adresu
            jsr     IIC_read_byte       ;nacti byte
            and     #%11110111          ;vynuluj alarm1
            tax                         ;uloz A do X
            lda     #$14                ;nacti adresu
            jsr     IIC_write_byte       ;zapis hodnotu
konec5:        
            pulh
            pulx
            rts
            
            
 ;*************************************************************************************
;*
;* podprogram readByte - nacte byte z volne pameti
;* byte resAlarm(byte adresa)
;*
;*************************************************************************************            

 isLeapYear:
            lda     #$05
            jsr     IIC_read_byte
            and     #%00100000
            lsra
            lsra
            lsra
            lsra
            lsra
            rts
            
;*************************************************************************************
;*
;* podprogram readByte - nacte byte z volne pameti
;* byte resAlarm(byte adresa)
;*
;*************************************************************************************            
readByte:
            cmp     #$20
            bge     prvni
            jmp     konec6
prvni:
            cmp     #$5F
            ble     druha
            jmp     konec6
druha:
            jsr     IIC_read_byte            
konec6:
            rts
            

;*************************************************************************************
;*
;* podprogram writeByte - zapise byte do volne pameti
;* void writeByte(byte hodnota, byte adresa)
;*
;*************************************************************************************            
writeByte:            
            cmp     #$20
            bge     prvni1
            jmp     konec7
prvni1:
            cmp     #$5F
            ble     druha1
            jmp     konec7
druha1:
            jsr     IIC_write_byte            
konec7:            
            rts
            

;*************************************************************************************
;*
;* podprogram resAlarm - vynuluje bit ktery se nastavi pri spusteni alarmu
;* void resAlarm(byte budik)
;*
;*************************************************************************************

alarm:      
            cmp     #1
            beq     prvni2
            cmp     #2
            beq     druha2
            jmp     konec8
prvni2:
            lda     #$0D
            jsr     IIC_read_byte
            jmp     konec8
druha2: 
            lda     #$14
            jsr     IIC_read_byte        
konec8:            
            and     #%00001000
            lsra
            lsra
            lsra
            rts

;*************************************************************************************
;*
;* pomocne podprogramy
;*
;*************************************************************************************

;((decimalByte / 10) << 4) | (decimalByte % 10)
toBCD:
            pshx
            pshh
            
            clrh
            ldx     #10
            div
            pshh
            lsla
            lsla
            lsla
            lsla
            ora     1,sp
            pulh
            
            pulh
            pulx
            rts


;(((bcdByte & 0xF0) >> 4) * 10) + (bcdByte & 0x0F)            
fromBCD:
            pshx
            pshh
            psha
            and     #%11110000
            lsra
            lsra
            lsra
            lsra
            ldx     #10
            mul
            psha
            
            lda     2,sp
            and     #%00001111
            add     1,sp
            tax
            pula
            pula
            txa
            
            pulh
            pulx
            rts
            


IIC_write_byte:
            pshx
            pshh
            psha
            
busy1:      
            feed_watchdog
            lda     IIC1S
            and     #%00100000
            cmp     #%00100000
            beq     busy1               ;cekej dokud nebude IIC volna, IIC1S_BUSY = 0
         
            bclr    TXAK,IIC1C          ;TXAK = 0
         
            lda     IIC1C
            ora     #%00110000
            sta     IIC1C               ;generovani START
         
            mov     #$DE,IIC1D          ;adresa RTC - zapis
            jsr     while2x             ;cekej na IBIF a RXAK
            
            lda     1,sp
            sta     IIC1D               ;poli adresu
            jsr     while2x
            
            lda     3,sp
            sta     IIC1D               ;poli data
            jsr     while2x
            
            bset    IICIF,IIC1S
         
            bclr    MST,IIC1C           ;STOP
         
            feed_watchdog
            pula
            pulh
            pulx 
            rts

        
IIC_read_byte:

            psha
            
busy2:      
            feed_watchdog
            lda     IIC1S
            and     #%00100000
            cmp     #%00100000
            beq     busy2
            
            bclr    TXAK,IIC1C          ;TXAK = 0
         
            lda     IIC1C
            ora     #%00110000
            sta     IIC1C               ;generovani START
         
            mov     #$DE,IIC1D          ;adresa RTC - zapis 
            jsr     while2x
        
            lda     1,sp                ; adresa bytu
            sta     IIC1D
            jsr     while2x
        
            bset    RSTA,IIC1C          ;opakuj START
            mov     #$DF,IIC1D          ;adresa RTC - teni
            jsr     while2x
            
            bclr    TX,IIC1C            ;rezim recieve
            bset    TXAK,IIC1C          ;zakaz ACK
            lda     IIC1D
            
while:      lda     IIC1S
            and     #%00000010
            cmp     #0
            beq     while
            bset    IICIF,IIC1S
                       
            bclr    MST,IIC1C           ;STOP
            pula
            lda     IIC1D               ;nati data
            
            feed_watchdog

            rts


while2x:
while1:     lda     IIC1S
            and     #%00000010
            cmp     #0
            beq     while1
            bset    IICIF,IIC1S
         
while2:     lda     IIC1S
            and     #%00000001
            cmp     #1
            beq     while2
            rts