#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */
#include "main_asm.h" /* interface to the assembly module */
#include "disp_gb60.h"
#include "RTC.h"
#include <stdio.h>

byte formatHodin = 0;
byte dny[2];
char radek1[20];
char radek2[20];
byte menu = 0;
byte mod = 0;
byte nastav = 0;
byte volba = 1;
byte value = 0;

void nastaveno(void);
void cekej(void);

void main(void) {
  
 
  ICGC1 = 0x7C;
  ICGC2 = 0x30;                 
  if (*(unsigned char*)0xFFBE != 0xFF) { /* Test if the device trim value is stored on the specified address */
    ICGTRM = *(unsigned char*)0xFFBE;  /* Initialize ICGTRM register from a non volatile memory */
  }
  while(!ICGS1_LOCK) {                 /* Wait */
  }


  asm_main(); /* call the assembly function */
  IIC_init();

  //Klavesnice
  PTADD = 0x00;	        //vstupni rezim
  PTAPE = 0xFF;         //pull up
  ATD1C = 0xE4;   	    // zapnuti prevodniku, 8 bit vysledek  
  ATD1PE = 1;         	// pin PTB0 prepneme do rezimu vstupu A/D prevodniku	
                         
  //Displej
  dinit();				    // Inicializace displeje
 	dcls();					    // Smazani displeje


  EnableInterrupts; /* enable interrupts */
   
   
  outFrequency(0,0);
  
 
 while(1){
 
  formatHodin = getTimeFormat();
    
    // tlacitko menu
    if ( PTAD_PTAD4 == 0 )
  	{
  	   if(menu){
  	    mod = 0;
  	    volba = 1;
  	    nastav = 0;
  	    menu = 0;
  	    cekej();
  	    cekej();
  	   }else
  	    menu = 1;
  	    cekej();
  	    cekej();
  	    dcls();  	    
  	}
  	
  	// menu
  	if(menu){
  
       // nastaven hodnot 
  	   if(nastav){
  	   
  	      ATD1SC = 0;	// start prevodu, jednorazovy, kanal 0
          while (ATD1SC_CCF == 0);
          
          if ( PTAD_PTAD5 == 0 )
        	{
    	        volba++;
    	        if( mod <= 2 && volba == 10)
    	          volba = 1;
    	        if( mod == 3 && volba == 6)
    	          volba = 1;
    	        if( mod == 4 && volba == 4)
    	          volba = 1;
    	        cekej();
    	        cekej();
    	        dcls();
    	    }
    	    
    	    if ( PTAD_PTAD6 == 0 )
        	{
    	        volba--;;
    	         if( mod <= 2 && volba == 0)
    	           volba = 9;
    	         if( mod == 3 && volba == 0)
    	           volba = 5;
    	         if( mod == 4 && volba == 0)
    	           volba = 3;
    	        cekej();
    	        cekej();
    	        dcls();
    	    }
    	    
    	   //nastav as    	    
    	   if(mod == 0){     
    	   
    	        switch(volba){
    	          case 1: value = ((ATD1RH*7)/256) + 1;
    	                  sprintf(radek1,"%s: %d ","den v Tydnu",value); break;
    	          case 2: value = ((ATD1RH*31)/256) + 1;
    	                  sprintf(radek1,"%s: %d ","den v Mesici",value);break;
    	          case 3: value = ((ATD1RH*12)/256) + 1;
    	                  sprintf(radek1,"%s: %d ","Mesic",value);break;
    	          case 4: value = ((ATD1RH*100)/256);
    	                  sprintf(radek1,"%s: %d ","Rok",value);break;
    	          case 5: value = ((ATD1RH*24)/256);
    	                  sprintf(radek1,"%s: %d ","Hodiny",value);break;
    	          case 6: value = ((ATD1RH*60)/256) ;
    	                  sprintf(radek1,"%s: %d ","Minuty",value);break;
    	          case 7: value = ((ATD1RH*60)/256);
    	                  sprintf(radek1,"%s: %d ","Sekundy",value);break;
    	          default:  if(formatHodin) {
                	          if(volba == 8){
                	            value = ((ATD1RH*2)/256);
                	            sprintf(radek1,"%s: %d ","AM/PM",value);
                	          }else
                	            sprintf(radek1,"%s","Exit"); 
              	          }else{
              	              
              	              sprintf(radek1,"%s","Exit");
              	          }break;
    	        }
    	        
    	       
    	   }
    	   
    	   // nastavit budik 1 nebo budik 2
    	   if(mod == 1 || mod == 2){    
    	       switch(volba){
    	          case 1: value = ((ATD1RH*8)/256);
    	                  sprintf(radek1,"%s: %d ","Rezim",value);break;
    	          case 2: value = ((ATD1RH*7)/256) + 1;
    	                  sprintf(radek1,"%s: %d ","den v Tydnu",value); break;
    	          case 3: value = ((ATD1RH*31)/256) + 1;
    	                  sprintf(radek1,"%s: %d ","den v Mesici",value);break;
    	          case 4: value = ((ATD1RH*12)/256) + 1;
    	                  sprintf(radek1,"%s: %d ","Mesic",value);break;
    	          case 5: value = ((ATD1RH*24)/256);
    	                  sprintf(radek1,"%s: %d ","Hodiny",value);break;
    	          case 6: value = ((ATD1RH*60)/256) ;
    	                  sprintf(radek1,"%s: %d ","Minuty",value);break;
    	          case 7: value = ((ATD1RH*60)/256);
    	                  sprintf(radek1,"%s: %d ","Sekundy",value);break;
    	          default: if(formatHodin) {
                	          if(volba == 8){
                	            value = ((ATD1RH*2)/256);
                	            sprintf(radek1,"%s: %d ","AM/PM",value);
                	          }else
                	            sprintf(radek1,"%s","Exit");
              	          }else{
              	              sprintf(radek1,"%s","Exit");
              	          }break;
    	        } 
    	   }
    	   
    	   // aktivace budiku
    	   if(mod == 3){    
    	        
    	        switch(volba){
    	          case 1: sprintf(radek1,"Oba vypnute"); value = 0;break;
    	          case 2: sprintf(radek1,"Budik 1"); value = 1;break;
    	          case 3: sprintf(radek1,"Budik 2"); value = 2;break;
    	          case 4: sprintf(radek1,"Oba zapnute"); value = 3;break;
    	          case 5: sprintf(radek1,"Exit"); break;
    	          default: break;                  
    	        }
    	   }
    	   
    	   // vyber formatu hodin
    	   if(mod == 4){
    	      if(volba == 1){ 
    	        sprintf(radek1,"24 hod. format");
    	        value = 0;
    	      }
    	      if(volba == 2){
    	        sprintf(radek1,"12 hod. format");
    	        value = 1;
    	      }
    	      if(volba == 3){
    	        sprintf(radek1,"Exit");
    	      }   	    
    	   }        
    	   
    	   // exit
    	   if(mod == 5){
    	        nastav = 0;
    	        volba = 1;
    	        mod = 0;
    	        menu = 0;  
    	   }
    	   
    	   // tlacitko potvrzeni
    	   if( PTAD_PTAD7 == 0){
      	     if(volba == 9 || (formatHodin == 0 && volba == 8) || 
      	        (mod == 3 && volba == 5) || (mod == 4 && volba == 3)){
      	        nastav = 0;
      	        mod = 0;
      	        volba = 1;
      	     }else{    
      	      
        	     if(mod == 0)
        	        setTime(volba, value);
        	     
        	     if(mod == 1 || mod == 2)
        	        setAlarm(mod, volba, value);
        	     
        	     if(mod == 3){
        	        enableAlarm(value);
        	     }
        	     
        	     if(mod == 4)
        	        setTimeFormat(value);
      	       nastaveno();
      	     }
      	     cekej();
      	     cekej();
      	     dcls();
          }
          setcursor(1,1);
    	    dtext(radek1);
  	    
  	   // vyber modu
  	   }else{
  	      	    	     
  	     if ( PTAD_PTAD5 == 0 )
        	{
    	        mod++;
    	        if(mod == 6)
    	          mod = 0;
    	        cekej();
    	        cekej();
    	        dcls();
    	    }
    	    
    	    if ( PTAD_PTAD6 == 0 )
        	{
    	        mod--;
    	        if(mod > 6)
    	          mod = 5;
    	        cekej();
    	        cekej();
    	        dcls();
    	    }
    	    
    	    if(mod == 0){
    	        sprintf(radek1,"Nastavit cas");  
    	    }
    	    if(mod == 1){
    	        sprintf(radek1,"Nastavit budik 1");  
    	    }
    	    if(mod == 2){
    	        sprintf(radek1,"Nastavit budik 2");
    	    }
    	    if(mod == 3){
    	        sprintf(radek1,"Aktivovat budik");
    	        volba = 1;
    	    }
    	    if(mod == 4){
    	        sprintf(radek1,"Format hodin");
    	        volba = 1; 
    	    }
  	      if(mod == 5){
    	        sprintf(radek1,"Exit");
    	    }
    	     
    	    setcursor(1,1);
    	    dtext(radek1);
    	    
    	    if( PTAD_PTAD7 == 0){
      	     nastav = 1;
      	     cekej();
      	     cekej();
      	     dcls();
         } 	    
  	   }

    	    
    //konec menu, vypis hodin a reset budiku
  	}else{  

    	 if ( PTAD_PTAD5 == 0 )
    	{
    	    resAlarm(1);
    	    cekej(); 	    
    	}
    	
    	 if ( PTAD_PTAD6 == 0 )
    	{
    	    resAlarm(2);
    	    cekej();
    	} 
  	  
      if ( PTAD_PTAD1 == 0 )
    	{
    	  dcls();
    	  setcursor(1,1);
    	  
    	  if(alarm(1) == 1){
    	    dtext("Budik 1");
    	  }else if(alarm(2) == 1){
    	    dtext("Budik 2");	   
    	  }

    	}else{        
    	
    	  switch(getTime(1)){
    	    case 1: sprintf(dny, "Po"); break;
    	    case 2: sprintf(dny, "Ut"); break;
    	    case 3: sprintf(dny, "St"); break;
    	    case 4: sprintf(dny, "Ct"); break;
    	    case 5: sprintf(dny, "Pa"); break;
    	    case 6: sprintf(dny, "So"); break;
    	    case 7: sprintf(dny, "Ne"); break;
    	    default:sprintf(dny, "--"); break; 
    	  }
    	 
      	setcursor(1,1);  
        sprintf(radek1, "%s %02d.%02d.20%02d",dny, getTime(2), getTime(3),getTime(4));
        dtext(radek1);
       
        
        if(formatHodin){
          sprintf(radek2, "%02d:%02d:%02d %s",getTime(5), getTime(6),getTime(7), (getTime(8) == 0) ? "AM" : "PM");
        }else{
          sprintf(radek2, "%02d:%02d:%02d",getTime(5), getTime(6),getTime(7));  
        }     
         setcursor(2,4);
        dtext(radek2); 
 
    	}  
    }      
     cekej();
     __RESET_WATCHDOG(); 
  }
}

// Potvrzeni nastaveni
void nastaveno(void){
  dcls();
  setcursor(1,1);
  dtext("Nastaveno");
  cekej();
  cekej();
  cekej();
  cekej();
  cekej();

}

void cekej() {
  unsigned int i;
  for (i = 0; i < 0xFFFF; i++ )
    __RESET_WATCHDOG(); 
}

